define('dummy/tests/acceptance/actions-test', ['exports', 'qunit', 'dummy/tests/helpers/module-for-acceptance', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsHelpersModuleForAcceptance, _dummyTestsPageObject) {

  (0, _dummyTestsHelpersModuleForAcceptance['default'])('Acceptance | actions');

  var clickOnText = _dummyTestsPageObject['default'].clickOnText;
  var clickable = _dummyTestsPageObject['default'].clickable;
  var fillable = _dummyTestsPageObject['default'].fillable;
  var value = _dummyTestsPageObject['default'].value;
  var visitable = _dummyTestsPageObject['default'].visitable;

  var page = _dummyTestsPageObject['default'].create({
    visit: visitable('/calculator'),
    keys: {
      clickOn: clickOnText('.numbers'),
      sum: clickable('button', { scope: '.operators', at: 0 }),
      equal: clickable('button', { scope: '.operators', at: 2 })
    },

    screen: value('.screen input'),
    fillValue: fillable('.screen input')
  });

  (0, _qunit.test)('allows to chain actions', function (assert) {
    page.visit().keys.clickOn('1').clickOn('2').sum().clickOn('3').equal();

    andThen(function () {
      assert.equal(page.screen, '15');
    });

    page.fillValue('45').keys.clickOn('6');

    andThen(function () {
      assert.equal(page.screen, '456');
    });
  });
});
define('dummy/tests/acceptance/actions-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - acceptance');
  QUnit.test('acceptance/actions-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'acceptance/actions-test.js should pass jshint.');
  });
});
define("dummy/tests/acceptance/default-properties-test", ["exports"], function (exports) {});
// import { test } from 'qunit';
// import moduleForAcceptance from '../helpers/module-for-acceptance';
// import PageObject from '../page-object';
//
// moduleForAcceptance('Acceptance | default properties');
//
// var {
//   visitable
// } = PageObject;
//
// test('Adds default properties', function(assert) {
//   var page = PageObject.create({
//     visit: visitable('/calculator'),
//
//     one: {
//       scope: '.numbers button:nth-of-type(1)'
//     },
//
//     screen: {
//       scope: '.screen'
//     }
//   });
//
//   page
//     .visit()
//     .clickOn('9')
//     .one()
//     .click();
//
//   andThen(function() {
//     assert.equal(page.screen().text(), '91', 'text');
//     assert.ok(page.screen().contains('91'), 'contains');
//     assert.ok(!page.screen().contains('99'), 'not contains');
//     assert.ok(page.screen().isVisible(), 'isVisible');
//     assert.ok(!page.screen().isHidden(), 'isHidden');
//   });
// });
//
// test('Overrides default properties', function(assert) {
//   var page = PageObject.create({
//     dummy: {
//       isHidden() {
//         return 'isHidden';
//       },
//       isVisible() {
//         return 'isVisible';
//       },
//       clickOn() {
//         return 'clickOn';
//       },
//       click() {
//         return 'click';
//       },
//       contains() {
//         return 'contains';
//       },
//       text() {
//         return 'text';
//       }
//     }
//   });
//
//   andThen(function() {
//     assert.equal(page.dummy().isHidden(), 'isHidden');
//     assert.equal(page.dummy().isVisible(), 'isVisible');
//     assert.equal(page.dummy().clickOn(), 'clickOn');
//     assert.equal(page.dummy().click(), 'click');
//     assert.equal(page.dummy().contains(), 'contains');
//     assert.equal(page.dummy().text(), 'text');
//   });
// });
define('dummy/tests/acceptance/default-properties-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - acceptance');
  QUnit.test('acceptance/default-properties-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'acceptance/default-properties-test.js should pass jshint.');
  });
});
define('dummy/tests/app.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - .');
  QUnit.test('app.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'app.js should pass jshint.');
  });
});
define('dummy/tests/controllers/calculator.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - controllers');
  QUnit.test('controllers/calculator.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'controllers/calculator.js should pass jshint.');
  });
});
define('dummy/tests/helpers/destroy-app', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = destroyApp;

  function destroyApp(application) {
    _ember['default'].run(application, 'destroy');
  }
});
define('dummy/tests/helpers/destroy-app.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - helpers');
  QUnit.test('helpers/destroy-app.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/destroy-app.js should pass jshint.');
  });
});
define('dummy/tests/helpers/module-for-acceptance', ['exports', 'qunit', 'dummy/tests/helpers/start-app', 'dummy/tests/helpers/destroy-app'], function (exports, _qunit, _dummyTestsHelpersStartApp, _dummyTestsHelpersDestroyApp) {
  exports['default'] = function (name) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    (0, _qunit.module)(name, {
      beforeEach: function beforeEach() {
        this.application = (0, _dummyTestsHelpersStartApp['default'])();

        if (options.beforeEach) {
          options.beforeEach.apply(this, arguments);
        }
      },

      afterEach: function afterEach() {
        (0, _dummyTestsHelpersDestroyApp['default'])(this.application);

        if (options.afterEach) {
          options.afterEach.apply(this, arguments);
        }
      }
    });
  };
});
define('dummy/tests/helpers/module-for-acceptance.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - helpers');
  QUnit.test('helpers/module-for-acceptance.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/module-for-acceptance.js should pass jshint.');
  });
});
define('dummy/tests/helpers/resolver', ['exports', 'ember/resolver', 'dummy/config/environment'], function (exports, _emberResolver, _dummyConfigEnvironment) {

  var resolver = _emberResolver['default'].create();

  resolver.namespace = {
    modulePrefix: _dummyConfigEnvironment['default'].modulePrefix,
    podModulePrefix: _dummyConfigEnvironment['default'].podModulePrefix
  };

  exports['default'] = resolver;
});
define('dummy/tests/helpers/resolver.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - helpers');
  QUnit.test('helpers/resolver.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/resolver.js should pass jshint.');
  });
});
define('dummy/tests/helpers/start-app', ['exports', 'ember', 'dummy/app', 'dummy/config/environment'], function (exports, _ember, _dummyApp, _dummyConfigEnvironment) {
  exports['default'] = startApp;

  function startApp(attrs) {
    var application = undefined;

    var attributes = _ember['default'].merge({}, _dummyConfigEnvironment['default'].APP);
    attributes = _ember['default'].merge(attributes, attrs); // use defaults, but you can override;

    _ember['default'].run(function () {
      application = _dummyApp['default'].create(attributes);
      application.setupForTesting();
      application.injectTestHelpers();
    });

    return application;
  }
});
define('dummy/tests/helpers/start-app.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - helpers');
  QUnit.test('helpers/start-app.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/start-app.js should pass jshint.');
  });
});
define('dummy/tests/page-object/create', ['exports', 'ember', 'ceibo', 'dummy/tests/page-object/properties/text', 'dummy/tests/page-object/properties/is-visible', 'dummy/tests/page-object/properties/is-hidden', 'dummy/tests/page-object/properties/click-on-text', 'dummy/tests/page-object/properties/clickable', 'dummy/tests/page-object/properties/contains'], function (exports, _ember, _ceibo, _dummyTestsPageObjectPropertiesText, _dummyTestsPageObjectPropertiesIsVisible, _dummyTestsPageObjectPropertiesIsHidden, _dummyTestsPageObjectPropertiesClickOnText, _dummyTestsPageObjectPropertiesClickable, _dummyTestsPageObjectPropertiesContains) {
  exports.create = create;
  var merge = _ember['default'].merge;

  function plugDefaultProperties(definition) {
    if (typeof definition.isVisible === 'undefined') {
      definition.isVisible = (0, _dummyTestsPageObjectPropertiesIsVisible.isVisible)();
    }

    if (typeof definition.isHidden === 'undefined') {
      definition.isHidden = (0, _dummyTestsPageObjectPropertiesIsHidden.isHidden)();
    }

    if (typeof definition.clickOn === 'undefined') {
      definition.clickOn = (0, _dummyTestsPageObjectPropertiesClickOnText.clickOnText)();
    }

    if (typeof definition.click === 'undefined') {
      definition.click = (0, _dummyTestsPageObjectPropertiesClickable.clickable)();
    }

    if (typeof definition.contains === 'undefined') {
      definition.contains = (0, _dummyTestsPageObjectPropertiesContains.contains)();
    }

    if (typeof definition.text === 'undefined') {
      definition.text = (0, _dummyTestsPageObjectPropertiesText.text)();
    }
  }

  /**
   * See https://github.com/san650/ceibo#examples for more info on how Ceibo
   * builders work.
   */
  function buildObject(builder, target, key, definition) {
    var container = {};

    plugDefaultProperties(definition);

    // Create child component
    _ceibo['default'].defineProperty(target, key, container);

    // Recursion
    builder.processNode(definition, container, target);
  }

  /**
   * Creates a new PageObject
   *
   * @example
   *
   *   var page = PageObject.create({
   *     title: text('.title')
   *   });
   *
   *   assert.equal(page.title, 'Dummy title');
   *
   * @param {Object} definition - PageObject definition
   * @param {Object} options - [private] Ceibo options. Do not use!
   * @return {PageObject}
   */

  function create(definition) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    var builder = {
      object: buildObject
    };

    return _ceibo['default'].create(definition, merge({ builder: builder }, options));
  }
});
define('dummy/tests/page-object/helpers', ['exports', 'ember', 'ceibo'], function (exports, _ember, _ceibo) {
  var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

  exports.buildSelector = buildSelector;
  exports.findElementWithAssert = findElementWithAssert;
  exports.findElement = findElement;
  exports.normalizeText = normalizeText;
  exports.every = every;
  exports.map = map;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

  var $ = _ember['default'].$;
  var assert = _ember['default'].assert;

  var Selector = (function () {
    function Selector(node, scope, selector, filters) {
      _classCallCheck(this, Selector);

      this.targetNode = node;
      this.targetScope = scope || '';
      this.targetSelector = selector || '';
      this.targetFilters = filters;
    }

    _createClass(Selector, [{
      key: 'toString',
      value: function toString() {
        var scope, filters;

        if (this.targetFilters.resetScope) {
          scope = this.targetScope;
        } else {
          scope = this.calculateScope(this.targetNode, this.targetScope);
        }

        filters = this.calculateFilters(this.targetFilters);

        return $.trim(scope + ' ' + this.targetSelector + filters);
      }
    }, {
      key: 'calculateFilters',
      value: function calculateFilters() {
        var filters = [];

        if (this.targetFilters.contains) {
          filters.push(':contains("' + this.targetFilters.contains + '")');
        }

        if (typeof this.targetFilters.at === 'number') {
          filters.push(':eq(' + this.targetFilters.at + ')');
        } else if (this.targetFilters.last) {
          filters.push(':last');
        }

        return filters.join('');
      }
    }, {
      key: 'calculateScope',
      value: function calculateScope(node, targetScope) {
        var scopes = this.getScopes(node);

        scopes.reverse();
        scopes.push(targetScope);

        return $.trim(scopes.join(' '));
      }
    }, {
      key: 'getScopes',
      value: function getScopes(node) {
        var scopes = [];

        if (node.scope) {
          scopes.push(node.scope);
        }

        if (!node.resetScope && _ceibo['default'].parent(node)) {
          scopes = scopes.concat(this.calculateScope(_ceibo['default'].parent(node)));
        }

        return scopes;
      }
    }]);

    return Selector;
  })();

  function guardMultiple(items, selector, supportMultiple) {
    assert('"' + selector + '" matched more than one element. If this is not an error use { multiple: true }', supportMultiple || items.length <= 1);
  }

  /**
   * Creates a fully qualified selector
   *
   * @param {Ceibo} node - Node of the tree
   * @param {string} targetSelector - Specific CSS selector
   * @param {Object} options - Additional options
   * @param {boolean} options.resetScope - Do not use inherited scope
   * @param {string} options.contains - Filter by using :contains('foo') pseudo-class
   * @param {number} options.at - Filter by index using :eq(x) pseudo-class
   * @param {boolean} options.last - Filter by using :last pseudo-class
   * @return {string} Full qualified selector
   */

  function buildSelector(node, targetSelector, options) {
    return new Selector(node, options.scope, targetSelector, options).toString();
  }

  /**
   * Return a jQuery element or raise an exception if the element doesn't exist
   *
   * @param {Ceibo} node - Node of the tree
   * @param {string} targetSelector - Specific CSS selector
   * @param {Object} options - Additional options
   * @param {boolean} options.resetScope - Do not use inherited scope
   * @param {string} options.contains - Filter by using :contains('foo') pseudo-class
   * @param {number} options.at - Filter by index using :eq(x) pseudo-class
   * @param {boolean} options.last - Filter by using :last pseudo-class
   * @return {Object} jQuery object
   */

  function findElementWithAssert(node, targetSelector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    var selector = buildSelector(node, targetSelector, options);
    var result = findWithAssert(selector);

    guardMultiple(result, selector, options.multiple);

    return result;
  }

  /**
   * Return a jQuery element (can be an empty jQuery result)
   *
   * @param {Ceibo} node - Node of the tree
   * @param {string} targetSelector - Specific CSS selector
   * @param {Object} options - Additional options
   * @param {boolean} options.resetScope - Do not use inherited scope
   * @param {string} options.contains - Filter by using :contains('foo') pseudo-class
   * @param {number} options.at - Filter by index using :eq(x) pseudo-class
   * @param {boolean} options.last - Filter by using :last pseudo-class
   * @return {Object} jQuery object
   */

  function findElement(node, targetSelector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    var selector = buildSelector(node, targetSelector, options);
    var result = find(selector);

    guardMultiple(result, selector, options.multiple);

    return result;
  }

  /**
   * Trim whitespaces at both ends and normalize whitespaces inside `text`
   *
   * Due to variations in the HTML parsers in different browsers, the text
   * returned may vary in newlines and other white space.
   *
   * @see http://api.jquery.com/text/
   */

  function normalizeText(text) {
    return $.trim(text).replace(/\n/g, ' ').replace(/\s\s*/g, ' ');
  }

  function every(jqArray, cb) {
    var arr = jqArray.get();

    return _ember['default'].A(arr).every(function (element) {
      return cb($(element));
    });
  }

  function map(jqArray, cb) {
    var arr = jqArray.get();

    return _ember['default'].A(arr).map(function (element) {
      return cb($(element));
    });
  }
});
define('dummy/tests/page-object/properties/attribute', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.attribute = attribute;

  /**
   * Gets the value of an attribute from an element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     imageAlternateText: attribute('alt', '.img')
   *   });
   *
   *   assert.equal(page.imageAlternateText, 'Logo');
   *
   * @param {string} attributeName - Name of the attribute to get
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @param {boolean} options.multiple - Return an array of values
   * @return {Descriptor}
   */

  function attribute(attributeName, selector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    return {
      isDescriptor: true,

      get: function get() {
        var elements = (0, _dummyTestsPageObjectHelpers.findElementWithAssert)(this, selector, options);
        var result;

        result = (0, _dummyTestsPageObjectHelpers.map)(elements, function (element) {
          return element.attr(attributeName);
        });

        return options.multiple ? result : result[0];
      }
    };
  }
});
define('dummy/tests/page-object/properties/click-on-text', ['exports', 'ember', 'dummy/tests/page-object/helpers'], function (exports, _ember, _dummyTestsPageObjectHelpers) {
  exports.clickOnText = clickOnText;

  /* global wait, find, click */

  var merge = _ember['default'].merge;

  function findChildElement(tree, selector, textToClick, options) {
    // Suppose that we have something like `<form><button>Submit</button></form>`
    // In this case <form> and <button> elements contains "Submit" text, so, we'll
    // want to __always__ click on the __last__ element that contains the text.
    var selctorWithSpace = (selector || '') + ' ';
    var fullSelector = (0, _dummyTestsPageObjectHelpers.buildSelector)(tree, selctorWithSpace, merge({ contains: textToClick, last: true }, options));

    if (find(fullSelector).length) {
      return fullSelector;
    }
  }

  function findElement(tree, selector, textToClick, options) {
    var fullSelector = (0, _dummyTestsPageObjectHelpers.buildSelector)(tree, selector, merge({ contains: textToClick }, options));

    return fullSelector;
  }

  /**
   * Creates an action to click an element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     clickOn: clickOnText('body')
   *   });
   *
   *   page.clickOn('Save');
   *
   * @param {string} selector - CSS selector of the element to click
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function clickOnText(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      value: function value(textToClick) {
        var _this = this;

        wait().then(function () {
          var actualSelector = findChildElement(_this, selector, textToClick, options) || findElement(_this, selector, textToClick, options);

          click(actualSelector);
        });

        return this;
      }
    };
  }
});
define('dummy/tests/page-object/properties/clickable', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.clickable = clickable;

  /**
   * Creates an action to click an element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     submit: clickable('button[type=submit]')
   *   });
   *
   *   page.submit();
   *
   * @param {string} selector - CSS selector of the element to click
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @param {boolean} options.resetScope - Ignore parent scope
   * @return {Descriptor}
   */

  function clickable(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      value: function value() {
        /* global click */
        click((0, _dummyTestsPageObjectHelpers.buildSelector)(this, selector, options));

        return this;
      }
    };
  }
});
define('dummy/tests/page-object/properties/collection', ['exports', 'ember', 'dummy/tests/page-object/helpers', 'dummy/tests/page-object/create', 'dummy/tests/page-object/properties/count'], function (exports, _ember, _dummyTestsPageObjectHelpers, _dummyTestsPageObjectCreate, _dummyTestsPageObjectPropertiesCount) {
  exports.collection = collection;

  function merge(target) {
    for (var _len = arguments.length, objects = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      objects[_key - 1] = arguments[_key];
    }

    objects.forEach(function (o) {
      return _ember['default'].merge(target, o);
    });

    return target;
  }

  function generateEnumerable(definition) {
    var enumerable = merge({}, definition);

    delete enumerable.itemScope;

    if (typeof enumerable.count === 'undefined') {
      enumerable.count = (0, _dummyTestsPageObjectPropertiesCount.count)(definition.itemScope);
    }

    return (0, _dummyTestsPageObjectCreate.create)(enumerable);
  }

  function generateItem(index, definition) {
    var filters = merge({}, { scope: definition.scope, at: index });
    var scope = (0, _dummyTestsPageObjectHelpers.buildSelector)({}, definition.itemScope, filters);

    return (0, _dummyTestsPageObjectCreate.create)(merge({}, definition.item, { scope: scope, resetScope: definition.resetScope }), { parent: this });
  }

  /**
   * Creates a component that represents a collection of items
   *
   * @example
   *
   *   var page = PageObject.create({
   *     users: collection({
   *       itemScope: 'table tr',
   *
   *       item: {
   *         firstName: text('td', { at: 0 })
   *         lastName: text('td', { at: 1 })
   *       }
   *   });
   *
   *   assert.equal(page.users().count(), 2);
   *   assert.equal(page.users(1).firstName, 'John');
   *   assert.equal(page.users(1).lastName, 'Doe');
   *
   * @param {Object} definition - Collection definition
   * @param {String} definition.itemScope - CSS selector
   * @param {Object} definition.item - Item definition
   * @return {Descriptor}
   */

  function collection(definition) {
    return {
      isDescriptor: true,

      value: function value(index) {
        if (typeof index === 'number') {
          return generateItem.call(this, index, definition);
        } else {
          return generateEnumerable.call(this, definition);
        }
      }
    };
  }
});
define('dummy/tests/page-object/properties/contains', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.contains = contains;

  /**
   * Creates a predicate to validate if an element contains a subtext
   *
   * @example
   *   <h1> Page Title </h1>
   *
   *   var page = PageObject.create({
   *     titleIncludes: contains('h1')
   *   });
   *
   *   assert.ok(page.titleIncludes('Page'));
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function contains(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      value: function value(textToSearch) {
        var elements = (0, _dummyTestsPageObjectHelpers.findElementWithAssert)(this, selector, options);

        return (0, _dummyTestsPageObjectHelpers.every)(elements, function (element) {
          return element.text().indexOf(textToSearch) >= 0;
        });
      }
    };
  }
});
define('dummy/tests/page-object/properties/count', ['exports', 'ember', 'dummy/tests/page-object/helpers'], function (exports, _ember, _dummyTestsPageObjectHelpers) {
  exports.count = count;

  var $ = _ember['default'].$;

  /**
   * Gets the count of matched elements
   *
   * @example
   *
   *   var page = PageObject.create({
   *     imageCount: count('.img')
   *   });
   *
   *   assert.equal(page.imageCount(), 2);
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Add scope
   * @param {boolean} options.resetScope - Ignore parent scope
   * @return {Descriptor}
   */

  function count(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      get: function get() {
        var countOptions = {};

        $.extend(true, countOptions, options, { multiple: true });

        return (0, _dummyTestsPageObjectHelpers.findElement)(this, selector, countOptions).length;
      }
    };
  }
});
define('dummy/tests/page-object/properties/fillable', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.fillable = fillable;

  /**
   * Creates an action to fill in an input
   *
   * @example
   *
   *   var page = PageObject.create({
   *     name: fillable('#name')
   *   });
   *
   *   page.name('John Doe');
   *
   * @param {string} selector - CSS selector of the element to fill
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @param {boolean} options.resetScope - Ignore parent scope
   * @return {Descriptor}
   */

  function fillable(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      value: function value(textToUse) {
        /* global fillIn */
        fillIn((0, _dummyTestsPageObjectHelpers.buildSelector)(this, selector, options), textToUse);

        return this;
      }
    };
  }
});
define('dummy/tests/page-object/properties/has-class', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.hasClass = hasClass;

  /**
   * Creates a predicate to validate if an element has a given CSS class
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageActive: hasClass('is-active', '.img')
   *   });
   *
   *   assert.ok(page.isImageActive(), 'Image is active');
   *
   * @param {string} cssClass - Name of the CSS class to look for
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function hasClass(cssClass, selector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    return {
      isDescriptor: true,

      get: function get() {
        var elements = (0, _dummyTestsPageObjectHelpers.findElementWithAssert)(this, selector, options);

        return (0, _dummyTestsPageObjectHelpers.every)(elements, function (element) {
          return element.hasClass(cssClass);
        });
      }
    };
  }
});
define('dummy/tests/page-object/properties/is-hidden', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.isHidden = isHidden;

  /**
   * Creates a predicate to validate if an element is hidden
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageVisible: isVisible('.img')
   *   });
   *
   *   assert.ok(page.isImageVisible(), 'Image is visible');
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function isHidden(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      get: function get() {
        var elements = (0, _dummyTestsPageObjectHelpers.findElement)(this, selector, options);

        return (0, _dummyTestsPageObjectHelpers.every)(elements, function (element) {
          return element.is(':hidden');
        });
      }
    };
  }
});
define('dummy/tests/page-object/properties/is-visible', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.isVisible = isVisible;

  /**
   * Creates a predicate to validate if an element is visible
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageVisible: isVisible('.img')
   *   });
   *
   *   assert.ok(page.isImageVisible(), 'Image is visible');
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function isVisible(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      get: function get() {
        var elements = (0, _dummyTestsPageObjectHelpers.findElement)(this, selector, options);

        if (elements.length === 0) {
          return false;
        }

        return (0, _dummyTestsPageObjectHelpers.every)(elements, function (element) {
          return element.is(':visible');
        });
      }
    };
  }
});
define('dummy/tests/page-object/properties/not-has-class', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.notHasClass = notHasClass;

  /**
   * Creates a predicate to validate if an element doesn't have a given CSS class
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageDeactivated: notHasClass('is-active', '.img')
   *   });
   *
   *   assert.ok(page.isImageDeactivated(), 'Image is not active');
   *
   * @param {string} cssClass - Name of the CSS class to look for
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function notHasClass(cssClass, selector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    return {
      isDescriptor: true,

      get: function get() {
        var elements = (0, _dummyTestsPageObjectHelpers.findElementWithAssert)(this, selector, options);

        return (0, _dummyTestsPageObjectHelpers.every)(elements, function (element) {
          return !element.hasClass(cssClass);
        });
      }
    };
  }
});
define('dummy/tests/page-object/properties/text', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.text = text;

  /**
   * Gets the text of the matched element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     title: text('h1')
   *   });
   *
   *   assert.equal(page.title, 'Page title');
   *
   *   var page = PageObject.create({
   *     options: text('li', { multiple: true })
   *   });
   *
   *   assert.deepEqual(page.options, ['lorem', 'ipsum'])
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @param {boolean} options.resetScope - Ignore parent scope
   * @param {boolean} options.multiple - Return an array of values
   * @return {Descriptor}
   */

  function text(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      get: function get() {
        var elements = (0, _dummyTestsPageObjectHelpers.findElementWithAssert)(this, selector, options);
        var result;

        result = (0, _dummyTestsPageObjectHelpers.map)(elements, function (element) {
          return (0, _dummyTestsPageObjectHelpers.normalizeText)(element.text());
        });

        return options.multiple ? result : result[0];
      }
    };
  }
});
define('dummy/tests/page-object/properties/value', ['exports', 'dummy/tests/page-object/helpers'], function (exports, _dummyTestsPageObjectHelpers) {
  exports.value = value;

  /**
   * Gets the value of the matched element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     search: value('input')
   *   });
   *
   *   assert.equal(page.search, 'search term');
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.at - Reduce the set of matched elements to the one at the specified index
   * @param {boolean} options.resetScope - Ignore parent scope
   * @return {Descriptor}
   */

  function value(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    return {
      isDescriptor: true,

      get: function get() {
        var elements = (0, _dummyTestsPageObjectHelpers.findElementWithAssert)(this, selector, options);
        var result;

        result = (0, _dummyTestsPageObjectHelpers.map)(elements, function (element) {
          return element.val();
        });

        return options.multiple ? result : result[0];
      }
    };
  }
});
define('dummy/tests/page-object/properties/visitable', ['exports', 'ember'], function (exports, _ember) {
  exports.visitable = visitable;
  var merge = _ember['default'].merge;
  var $ = _ember['default'].$;

  function fillInDynamicSegments(path, params) {
    return path.split('/').map(function (segment) {
      var match = segment.match(/^:(.+)$/);

      if (match) {
        var key = match[1],
            value = params[key];

        if (typeof value === 'undefined') {
          throw new Error('Missing parameter for \'' + key + '\'');
        }

        // Remove dynamic segment key from params
        delete params[key];

        return value;
      }

      return segment;
    }).join('/');
  }

  function appendQueryParams(path, queryParams) {
    if (Object.keys(queryParams).length) {
      path += "?" + $.param(queryParams);
    }

    return path;
  }

  /**
   * Creates an action to load a route
   *
   * @example
   *
   *   var page = PageObject.create({
   *     visit: visitalbe('/users/:user_id')
   *   });
   *
   *   page.visit({ user_id: 10 });
   *
   * @param {string} path - Full path of the route to visit
   * @param {Object} dynamicSegments - Key and values to use to replace the dynamic segments
   * @param {Object} queryParams - Key and values to use as the Query Params
   * @return {Descriptor}
   */

  function visitable(path) {
    return {
      isDescriptor: true,

      value: function value() {
        var dynamicSegmentsAndQueryParams = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

        var params = merge({}, dynamicSegmentsAndQueryParams);
        var fullPath = fillInDynamicSegments(path, params);

        fullPath = appendQueryParams(fullPath, params);

        /* global visit */
        visit(fullPath);

        return this;
      }
    };
  }
});
define('dummy/tests/page-object', ['exports', 'dummy/tests/page-object/properties/attribute', 'dummy/tests/page-object/properties/click-on-text', 'dummy/tests/page-object/properties/clickable', 'dummy/tests/page-object/properties/collection', 'dummy/tests/page-object/properties/contains', 'dummy/tests/page-object/properties/count', 'dummy/tests/page-object/create', 'dummy/tests/page-object/properties/fillable', 'dummy/tests/page-object/properties/has-class', 'dummy/tests/page-object/properties/is-hidden', 'dummy/tests/page-object/properties/is-visible', 'dummy/tests/page-object/properties/not-has-class', 'dummy/tests/page-object/properties/text', 'dummy/tests/page-object/properties/value', 'dummy/tests/page-object/properties/visitable'], function (exports, _dummyTestsPageObjectPropertiesAttribute, _dummyTestsPageObjectPropertiesClickOnText, _dummyTestsPageObjectPropertiesClickable, _dummyTestsPageObjectPropertiesCollection, _dummyTestsPageObjectPropertiesContains, _dummyTestsPageObjectPropertiesCount, _dummyTestsPageObjectCreate, _dummyTestsPageObjectPropertiesFillable, _dummyTestsPageObjectPropertiesHasClass, _dummyTestsPageObjectPropertiesIsHidden, _dummyTestsPageObjectPropertiesIsVisible, _dummyTestsPageObjectPropertiesNotHasClass, _dummyTestsPageObjectPropertiesText, _dummyTestsPageObjectPropertiesValue, _dummyTestsPageObjectPropertiesVisitable) {
  Object.defineProperty(exports, 'attribute', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesAttribute.attribute;
    }
  });
  Object.defineProperty(exports, 'clickOnText', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesClickOnText.clickOnText;
    }
  });
  Object.defineProperty(exports, 'clickable', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesClickable.clickable;
    }
  });
  Object.defineProperty(exports, 'collection', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesCollection.collection;
    }
  });
  Object.defineProperty(exports, 'contains', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesContains.contains;
    }
  });
  Object.defineProperty(exports, 'count', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesCount.count;
    }
  });
  Object.defineProperty(exports, 'create', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectCreate.create;
    }
  });
  Object.defineProperty(exports, 'fillable', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesFillable.fillable;
    }
  });
  Object.defineProperty(exports, 'selectable', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesFillable.fillable;
    }
  });
  Object.defineProperty(exports, 'hasClass', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesHasClass.hasClass;
    }
  });
  Object.defineProperty(exports, 'isHidden', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesIsHidden.isHidden;
    }
  });
  Object.defineProperty(exports, 'isVisible', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesIsVisible.isVisible;
    }
  });
  Object.defineProperty(exports, 'notHasClass', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesNotHasClass.notHasClass;
    }
  });
  Object.defineProperty(exports, 'text', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesText.text;
    }
  });
  Object.defineProperty(exports, 'value', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesValue.value;
    }
  });
  Object.defineProperty(exports, 'visitable', {
    enumerable: true,
    get: function get() {
      return _dummyTestsPageObjectPropertiesVisitable.visitable;
    }
  });
  exports['default'] = {
    attribute: _dummyTestsPageObjectPropertiesAttribute.attribute,
    clickOnText: _dummyTestsPageObjectPropertiesClickOnText.clickOnText,
    clickable: _dummyTestsPageObjectPropertiesClickable.clickable,
    collection: _dummyTestsPageObjectPropertiesCollection.collection,
    contains: _dummyTestsPageObjectPropertiesContains.contains,
    count: _dummyTestsPageObjectPropertiesCount.count,
    create: _dummyTestsPageObjectCreate.create,
    fillable: _dummyTestsPageObjectPropertiesFillable.fillable,
    hasClass: _dummyTestsPageObjectPropertiesHasClass.hasClass,
    isHidden: _dummyTestsPageObjectPropertiesIsHidden.isHidden,
    isVisible: _dummyTestsPageObjectPropertiesIsVisible.isVisible,
    notHasClass: _dummyTestsPageObjectPropertiesNotHasClass.notHasClass,
    selectable: _dummyTestsPageObjectPropertiesFillable.fillable,
    text: _dummyTestsPageObjectPropertiesText.text,
    value: _dummyTestsPageObjectPropertiesValue.value,
    visitable: _dummyTestsPageObjectPropertiesVisitable.visitable
  };
});
define('dummy/tests/router.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - .');
  QUnit.test('router.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'router.js should pass jshint.');
  });
});
define('dummy/tests/test-helper', ['exports', 'dummy/tests/helpers/resolver', 'ember-qunit'], function (exports, _dummyTestsHelpersResolver, _emberQunit) {

  (0, _emberQunit.setResolver)(_dummyTestsHelpersResolver['default']);
});
define('dummy/tests/test-helper.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - .');
  QUnit.test('test-helper.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'test-helper.js should pass jshint.');
  });
});
define('dummy/tests/unit/actions/click-on-text-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .clickOnText');

  (0, _qunit.test)('calls Ember\'s click helper', function (assert) {
    assert.expect(2);

    (0, _dummyTestsUnitTestHelper.fixture)('\n    <fieldset>\n      <button>Lorem</button>\n      <button>Ipsum</button>\n    </fieldset>\n  ');

    var expectedSelector = undefined,
        page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.clickOnText)('fieldset'),
      bar: (0, _dummyTestsPageObject.clickOnText)('button')
    });

    andThen(function () {
      expectedSelector = 'fieldset :contains("Lorem"):last';
      page.foo('Lorem');
    });

    andThen(function () {
      expectedSelector = 'button:contains("Lorem")';
      page.bar('Lorem');
    });
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    assert.expect(2);

    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div class="scope">\n      <fieldset>\n        <button>Lorem</button>\n        <button>Ipsum</button>\n      </fieldset>\n    </div>\n  ');

    var expectedSelector = undefined,
        page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.clickOnText)('fieldset', { scope: '.scope' }),
      bar: (0, _dummyTestsPageObject.clickOnText)('button', { scope: '.scope' })
    });

    andThen(function () {
      expectedSelector = '.scope fieldset :contains("Lorem"):last';
      page.foo('Lorem');
    });

    andThen(function () {
      expectedSelector = '.scope button:contains("Lorem")';
      page.bar('Lorem');
    });
  });

  (0, _qunit.test)('looks for elements inside page\'s scope', function (assert) {
    assert.expect(2);

    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div class="scope">\n      <fieldset>\n        <button>Lorem</button>\n        <button>Ipsum</button>\n      </fieldset>\n    </div>\n  ');

    var page = undefined,
        expectedSelector = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',
      foo: (0, _dummyTestsPageObject.clickOnText)('fieldset'),
      bar: (0, _dummyTestsPageObject.clickOnText)('button')
    });

    andThen(function () {
      expectedSelector = '.scope fieldset :contains("Lorem"):last';
      page.foo('Lorem');
    });

    andThen(function () {
      expectedSelector = '.scope button:contains("Lorem")';
      page.bar('Lorem');
    });
  });

  (0, _qunit.test)('resets scope', function (assert) {
    assert.expect(2);

    (0, _dummyTestsUnitTestHelper.fixture)('\n    <fieldset>\n      <button>Lorem</button>\n      <button>Ipsum</button>\n    </fieldset>\n  ');

    var page = undefined,
        expectedSelector = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',
      foo: (0, _dummyTestsPageObject.clickOnText)('fieldset', { resetScope: true }),
      bar: (0, _dummyTestsPageObject.clickOnText)('button', { resetScope: true })
    });

    andThen(function () {
      expectedSelector = 'fieldset :contains("Lorem"):last';
      page.foo('Lorem');
    });

    andThen(function () {
      expectedSelector = 'button:contains("Lorem")';
      page.bar('Lorem');
    });
  });

  (0, _qunit.test)('returns target object', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.click = function () {};

    page = (0, _dummyTestsPageObject.create)({
      dummy: 'value',

      foo: (0, _dummyTestsPageObject.clickOnText)()
    });

    assert.equal(page.foo('dummy text'), page);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    assert.expect(2);

    (0, _dummyTestsUnitTestHelper.fixture)('\n    <fieldset>\n      <button>Lorem</button>\n      <button>Lorem</button>\n      <button>Lorem</button>\n      <button>Ipsum</button>\n    </fieldset>\n  ');

    var expectedSelector = undefined,
        page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.clickOnText)('fieldset', { at: 2 }),
      bar: (0, _dummyTestsPageObject.clickOnText)('button', { at: 2 })
    });

    andThen(function () {
      expectedSelector = 'fieldset :contains("Lorem"):eq(2)';
      page.foo('Lorem');
    });

    andThen(function () {
      expectedSelector = 'button:contains("Lorem"):eq(2)';
      page.bar('Lorem');
    });
  });
});
define('dummy/tests/unit/actions/click-on-text-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/actions');
  QUnit.test('unit/actions/click-on-text-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/actions/click-on-text-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/actions/clickable-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .clickable');

  (0, _qunit.test)('calls Ember\'s click helper', function (assert) {
    assert.expect(1);

    var expectedSelector = 'span',
        page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.clickable)(expectedSelector)
    });

    page.foo();
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, '.scope span');
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.clickable)('span', { scope: '.scope' })
    });

    page.foo();
  });

  (0, _qunit.test)('looks for elements inside page\'s scope', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, '.scope span');
    };

    page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.clickable)('span')
    });

    page.foo();
  });

  (0, _qunit.test)('resets scope', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, 'span');
    };

    page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',
      foo: (0, _dummyTestsPageObject.clickable)('span', { resetScope: true })
    });

    page.foo();
  });

  (0, _qunit.test)('returns target object', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.click = function () {};

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.clickable)()
    });

    assert.equal(page.foo(), page);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    assert.expect(1);

    var expectedSelector = 'span:eq(3)',
        page = undefined;

    window.click = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.clickable)('span', { at: 3 })
    });

    page.foo();
  });
});
define('dummy/tests/unit/actions/clickable-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/actions');
  QUnit.test('unit/actions/clickable-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/actions/clickable-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/actions/fillable-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .fillable');

  (0, _qunit.test)('calls Ember\'s fillIn helper', function (assert) {
    assert.expect(2);

    var expectedSelector = 'span',
        expectedText = 'dummy text',
        page = undefined;

    window.fillIn = function (actualSelector, actualText) {
      assert.equal(actualSelector, expectedSelector);
      assert.equal(actualText, expectedText);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.fillable)(expectedSelector)
    });

    page.foo(expectedText);
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.fillIn = function (actualSelector) {
      assert.equal(actualSelector, '.scope span');
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.fillable)('span', { scope: '.scope' })
    });

    page.foo('dummy text');
  });

  (0, _qunit.test)('looks for elements inside page\'s scope', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.fillIn = function (actualSelector) {
      assert.equal(actualSelector, '.scope span');
    };

    page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.fillable)('span')
    });

    page.foo('dummy text');
  });

  (0, _qunit.test)('resets scope', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.fillIn = function (actualSelector) {
      assert.equal(actualSelector, 'span');
    };

    page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',
      foo: (0, _dummyTestsPageObject.fillable)('span', { resetScope: true })
    });

    page.foo('dummy text');
  });

  (0, _qunit.test)('returns target object', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.fillIn = function () {};

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.fillable)()
    });

    assert.equal(page.foo(), page);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    assert.expect(1);

    var expectedSelector = 'span:eq(3)',
        page = undefined;

    window.fillIn = function (actualSelector) {
      assert.equal(actualSelector, expectedSelector);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.fillable)('span', { at: 3 })
    });

    page.foo();
  });

  (0, _qunit.test)('is aliased to selectable', function (assert) {
    assert.expect(2);

    var expectedSelector = 'span',
        expectedText = 'dummy text',
        page = undefined;

    window.fillIn = function (actualSelector, actualText) {
      assert.equal(actualSelector, expectedSelector);
      assert.equal(actualText, expectedText);
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.selectable)(expectedSelector)
    });

    page.foo(expectedText);
  });
});
define('dummy/tests/unit/actions/fillable-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/actions');
  QUnit.test('unit/actions/fillable-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/actions/fillable-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/actions/visitable-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .visitable');

  (0, _qunit.test)('calls Ember\'s visit helper', function (assert) {
    assert.expect(1);

    var expectedRoute = '/dummy-page';

    window.visit = function (actualRoute) {
      assert.equal(actualRoute, expectedRoute);
    };

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.visitable)(expectedRoute)
    });

    page.foo();
  });

  (0, _qunit.test)('fills in dynamic segments', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.visit = function (actualRoute) {
      assert.equal(actualRoute, '/users/5/comments/1');
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.visitable)('/users/:user_id/comments/:comment_id')
    });

    page.foo({ user_id: 5, comment_id: 1 });
  });

  (0, _qunit.test)("raises an exception if params aren't given for all dynamic segments", function (assert) {
    assert.expect(1);

    var page = undefined;

    try {
      page = (0, _dummyTestsPageObject.create)({
        foo: (0, _dummyTestsPageObject.visitable)('/users/:user_id')
      });

      page.foo();
    } catch (e) {
      assert.equal(e.message, "Missing parameter for 'user_id'");
    }
  });

  (0, _qunit.test)('appends query params to the path', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.visit = function (actualRoute) {
      assert.equal(actualRoute, '/dummy-page?hello=world&lorem=ipsum');
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.visitable)('/dummy-page')
    });

    page.foo({ hello: "world", lorem: "ipsum" });
  });

  (0, _qunit.test)('accepts both dynamic segments and query params', function (assert) {
    assert.expect(1);

    var page = undefined;

    window.visit = function (actualRoute) {
      assert.equal(actualRoute, '/users/1/0?hello=world&lorem=ipsum');
    };

    page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.visitable)('/users/:user_id/:another_id')
    });

    page.foo({ user_id: 1, another_id: 0, hello: "world", lorem: "ipsum" });
  });
});
define('dummy/tests/unit/actions/visitable-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/actions');
  QUnit.test('unit/actions/visitable-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/actions/visitable-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/components/collection-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .collection');

  (0, _qunit.test)('generates a count property', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>Lorem</span>\n    <span>Ipsum</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.collection)({
        itemScope: 'span'
      })
    });

    assert.equal(page.foo().count, 2);
  });

  (0, _qunit.test)('does not override custom count property', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>Lorem</span>\n    <span>Ipsum</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.collection)({
        itemScope: 'span',

        count: 'custom count'
      })
    });

    assert.equal(page.foo().count, 'custom count');
  });

  (0, _qunit.test)('returns an item', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>Lorem</span>\n    <span>Ipsum</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.collection)({
        itemScope: 'span',

        item: {
          text: (0, _dummyTestsPageObject.text)()
        }
      })
    });

    assert.equal(page.foo(0).text, 'Lorem');
    assert.equal(page.foo(1).text, 'Ipsum');
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span>Lorem</span>\n    </div>\n    <div class="scope">\n      <span>Ipsum</span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.collection)({
        itemScope: 'span',
        hola: 'mundo',

        item: {
          text: (0, _dummyTestsPageObject.text)()
        }
      })
    });

    assert.equal(page.foo(0).text, 'Ipsum');
  });

  (0, _qunit.test)('looks for elements inside multiple scopes', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <ul>\n      <li>Blah</li>\n      <li>\n        <ul class="another-scope">\n          <li>Lorem<li>\n        </ul>\n      </li>\n    </ul>\n    <ul class="scope">\n      <li>Ipsum</li>\n      <li>\n        <ul>\n          <li>Dolor</li>\n        </ul>\n        <ul class="another-scope">\n          <li>Sit</li>\n          <li>Amet</li>\n        </ul>\n      </li>\n    </ul>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.collection)({
        itemScope: 'li',

        item: {
          bar: {
            scope: '.another-scope',

            text: (0, _dummyTestsPageObject.text)('li', { at: 0 })
          }
        }
      })
    });

    assert.equal(page.foo(1).bar.text, 'Sit');
  });

  (0, _qunit.test)('looks for elements inside collection\'s scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <ul>\n      <li>Lorem</li>\n    </ul>\n    <ul class="scope">\n      <li>Ipsum</li>\n    </ul>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.collection)({
        scope: '.scope',
        itemScope: 'li',

        item: {
          text: (0, _dummyTestsPageObject.text)()
        }
      })
    });

    assert.equal(page.foo(0).text, 'Ipsum');
  });

  (0, _qunit.test)('returns collection\'s component', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>Lorem</span>\n    <span>Second</span>\n    <button>Submit</button>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.collection)({
        itemScope: 'span',

        text: (0, _dummyTestsPageObject.text)('button')
      })
    });

    assert.equal(page.foo().text, 'Submit');
  });

  (0, _qunit.test)('looks for elements inside collection\'s scope (collection component)', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span>Lorem</span>\n    </div>\n    <div class="scope">\n      <span>Ipsum</span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.collection)({
        scope: '.scope',
        itemScope: 'li',

        text: (0, _dummyTestsPageObject.text)('span')
      })
    });

    assert.equal(page.foo().text, 'Ipsum');
  });

  (0, _qunit.test)('resets scope for items', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span>Lorem</span>\n    </div>\n    <div class="scope">\n      <span>Ipsum</span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: 'div',

      foo: (0, _dummyTestsPageObject.collection)({
        resetScope: true,
        scope: '.scope',
        itemScope: 'span',

        item: {
          text: (0, _dummyTestsPageObject.text)()
        }
      })
    });

    assert.equal(page.foo(0).text, 'Ipsum');
  });

  (0, _qunit.test)('resets scope for collection\'s component', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span>Lorem</span>\n    </div>\n    <div class="scope">\n      <span>Ipsum</span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: 'div',

      foo: (0, _dummyTestsPageObject.collection)({
        resetScope: true,
        scope: '.scope',
        text: (0, _dummyTestsPageObject.text)('span')
      })
    });

    assert.equal(page.foo().text, 'Ipsum');
  });

  (0, _qunit.test)('sets correct scope to child collections', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span><em>Lorem</em></span></div>\n    <div class="scope"><span><em>Ipsum</em></span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.collection)({
        scope: '.scope',
        itemScope: 'span',

        item: {
          bar: (0, _dummyTestsPageObject.collection)({
            itemScope: 'em',
            item: {
              text: (0, _dummyTestsPageObject.text)()
            }
          })
        }
      })
    });

    assert.equal(page.foo(0).bar(0).text, 'Ipsum');
  });
});
define('dummy/tests/unit/components/collection-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/components');
  QUnit.test('unit/components/collection-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/components/collection-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/create-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject) {
  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .create');

  (0, _qunit.test)('creates new page object', function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: 'a value',
      bar: {
        baz: 'another value'
      }
    });

    assert.equal(page.foo, 'a value');
    assert.equal(page.bar.baz, 'another value');
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span class="scope">Lorem</span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.invalid-scope',

      foo: {
        scope: '.scope',
        resetScope: true,
        bar: (0, _dummyTestsPageObject.text)()
      }
    });

    assert.equal(page.foo.bar, 'Lorem');
  });

  (0, _qunit.test)('generates .isVisible property', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Lorem <span>ipsum</span>');

    var page = (0, _dummyTestsPageObject.create)({
      scope: 'span',
      foo: {}
    });

    assert.ok(page.isVisible, 'page is visible');
    assert.ok(page.foo.isVisible, 'component is visible');
  });

  (0, _qunit.test)('generates .isHidden property', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Lorem <span style="display:none">ipsum</span>');

    var page = (0, _dummyTestsPageObject.create)({
      scope: 'span',
      foo: {}
    });

    assert.ok(page.isHidden, 'page is hidden');
    assert.ok(page.foo.isHidden, 'component is hidden');
  });

  ['isVisible', 'isHidden', 'clickOn', 'click', 'contains', 'text'].forEach(function (prop) {
    (0, _qunit.test)('does not override .' + prop + ' property', function (assert) {
      var page = (0, _dummyTestsPageObject.create)(_defineProperty({}, prop, 'foo bar'));

      assert.equal(page[prop], 'foo bar');
    });
  });

  (0, _qunit.test)('generates .clickOn property', function (assert) {
    assert.expect(1);

    window.click = function () {
      assert.ok(true, 'click called');
    };

    var page = (0, _dummyTestsPageObject.create)({
      foo: {}
    });

    page.foo.clickOn();
  });

  (0, _qunit.test)('generates .click property', function (assert) {
    assert.expect(1);

    window.click = function () {
      assert.ok(true, 'click called');
    };

    var page = (0, _dummyTestsPageObject.create)({
      foo: {}
    });

    page.foo.click();
  });

  (0, _qunit.test)('generates .click property', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Ipsum <span>Dolor</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: {
        scope: 'span'
      }
    });

    assert.ok(page.foo.contains('or'), 'contains');
  });

  (0, _qunit.test)('generates .text property', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>Lorem</div>\n    <div class="scope">Ipsum <span>Dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',
      foo: {
        scope: 'span'
      }
    });

    assert.equal(page.text, 'Ipsum Dolor');
    assert.equal(page.foo.text, 'Dolor');
  });
});
define('dummy/tests/unit/create-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit');
  QUnit.test('unit/create-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/create-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/predicates/contains-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .contains');

  (0, _qunit.test)('returns true when the element contains the text', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Lorem <span>ipsum</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.contains)('span')
    });

    assert.ok(!page.foo('Not here'));
    assert.ok(page.foo('ipsum'));
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.contains)('span', { scope: '.scope' })
    });

    assert.ok(!page.foo('lorem'));
    assert.ok(page.foo('ipsum'));
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.contains)('span')
    });

    assert.ok(!page.foo('lorem'));
    assert.ok(page.foo('ipsum'));
  });

  (0, _qunit.test)('raises an error when the element doesn\'t exist', function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.contains)('.element')
    });

    assert.throws(function () {
      return page.foo('baz');
    }, 'Throws element not found error');
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.contains)('span', { at: 0, resetScope: true })
    });

    assert.ok(page.foo('lorem'));
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span> ipsum </span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.contains)('span')
    });

    page.foo('lorem');
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, returns false if not all elements contain text', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span>ipsum</span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.contains)('span', { multiple: true })
    });

    assert.ok(!page.foo('lorem'));
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, returns true if all elements contain text', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span>lorem</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.contains)('span', { multiple: true })
    });

    assert.ok(page.foo('lorem'));
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span>ipsum</span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.contains)('span', { at: 1 })
    });

    assert.ok(!page.foo('lorem'));
    assert.ok(page.foo('ipsum'));
  });
});
define('dummy/tests/unit/predicates/contains-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/predicates');
  QUnit.test('unit/predicates/contains-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/predicates/contains-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/predicates/has-class-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .hasClass');

  (0, _qunit.test)('returns true when the element has the class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<em class="lorem"></em><span class="ipsum"></span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('ipsum', 'span')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('returns false when the element doesn\'t have the class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<em class="lorem"></em><span class="ipsum"></span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('lorem', 'span')
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)("raises an error when the element doesn't exist", function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('lorem', 'span')
    });

    assert.throws(function () {
      return page.foo;
    });
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span class="lorem"></span>\n    </div>\n    <div class="scope">\n      <span class="ipsum"></span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('ipsum', 'span', { scope: '.scope' })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span class="lorem"></span>\n    </div>\n    <div class="scope">\n      <span class="ipsum"></span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.hasClass)('ipsum', 'span')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span class="lorem"></span>\n    </div>\n    <div class="scope">\n      <span class="ipsum"></span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.hasClass)('lorem', 'div:first span', { resetScope: true })
    });

    assert.ok(page.foo);
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="ipsum"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('lorem', 'span')
    });

    return page.foo;
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option returns false if not all elements have class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="ipsum"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('lorem', 'span', { multiple: true })
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option returns true if all elements have class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="lorem"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('lorem', 'span', { multiple: true })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="ipsum"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.hasClass)('ipsum', 'span', { at: 1 })
    });

    assert.ok(page.foo);
  });
});
define('dummy/tests/unit/predicates/has-class-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/predicates');
  QUnit.test('unit/predicates/has-class-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/predicates/has-class-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/predicates/is-hidden-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .isHidden');

  (0, _qunit.test)('returns true when the element is hidden', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Lorem <span style="display:none">ipsum</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('span')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)("returns true when the element doesn't exist in the DOM", function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('span')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('returns false when the element is visible', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Lorem <span>ipsum</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('span')
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span style="display:none">ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('span', { scope: '.scope' })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span style="display:none">ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.isHidden)('span')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span style="display:none">lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.isHidden)('span', { resetScope: true, at: 0 })
    });

    assert.ok(page.foo);
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <em style="display:none">ipsum</em>\n    <em style="display:none">dolor</em>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('em')
    });

    return page.foo;
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, returns true if all elements are hidden', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <em style="display:none">ipsum</em>\n    <em style="display:none">dolor</em>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('em', { multiple: true })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, returns false if some elements are visible', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <em>ipsum</em>\n    <em style="display:none">dolor</em>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('em', { multiple: true })
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <em>lorem</em>\n    <em>ipsum</em>\n    <em style="display:none">dolor</em>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isHidden)('em', { at: 2 })
    });

    assert.ok(page.foo);
  });
});
define('dummy/tests/unit/predicates/is-hidden-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/predicates');
  QUnit.test('unit/predicates/is-hidden-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/predicates/is-hidden-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/predicates/is-visible-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .isVisible');

  (0, _qunit.test)('returns true when the element is visible', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Lorem <span>ipsum</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('span')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('returns false when the element is hidden', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Lorem <span style="display:none">ipsum</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('span')
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('returns false when the element doesn\'t exist', function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('span')
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span style="display:none">lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('span', { scope: '.scope', at: 0 })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span style="display:none">lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.isVisible)('span', { at: 0 })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span style="display:none">ipsum</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.isVisible)('span', { resetScope: true, at: 0 })
    });

    assert.ok(page.foo);
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span> ipsum </span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('span')
    });

    return page.foo;
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, return false if not all elements are visible', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span style="display:none"> ipsum </span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('span', { multiple: true })
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, return true if all elements are visible', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('span', { multiple: true })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <em style="display:none">lorem</em>\n    <em style="display:none">ipsum</em>\n    <em>dolor</em>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.isVisible)('em', { at: 0 }),
      bar: (0, _dummyTestsPageObject.isVisible)('em', { at: 2 })
    });

    assert.ok(!page.foo);
    assert.ok(page.bar);
  });
});
define('dummy/tests/unit/predicates/is-visible-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/predicates');
  QUnit.test('unit/predicates/is-visible-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/predicates/is-visible-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/predicates/not-has-class-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .notHasClass');

  (0, _qunit.test)('returns false when the element has the class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<span class="lorem ipsum"></span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.notHasClass)('ipsum', '.lorem')
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('returns true when the element doesn\'t have the class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<span class="lorem"></span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.notHasClass)('ipsum', '.lorem')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('raises an error when the element doesn\'t exist', function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      elementDoesNotHaveError: (0, _dummyTestsPageObject.notHasClass)('has-error', '.element')
    });

    assert.throws(function () {
      return page.elementDoesNotHaveError;
    });
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span class="lorem"></span>\n    </div>\n    <div class="scope">\n      <span class="ipsum"></span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.notHasClass)('lorem', 'span', { scope: '.scope' })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span class="lorem"></span>\n    </div>\n    <div class="scope">\n      <span class="ipsum"></span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.notHasClass)('lorem', 'span')
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div>\n      <span class="lorem"></span>\n    </div>\n    <div class="scope">\n      <span class="ipsum"></span>\n    </div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.notHasClass)('ipsum', 'span', { resetScope: true, at: 0 })
    });

    assert.ok(page.foo);
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="ipsum"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.notHasClass)('lorem', 'span')
    });

    return page.foo;
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, returns true if no elements have class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="ipsum"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.notHasClass)('other-class', 'span', { multiple: true })
    });

    assert.ok(page.foo);
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option, returns false if some elements have class', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="ipsum"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.notHasClass)('lorem', 'span', { multiple: true })
    });

    assert.ok(!page.foo);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span class="lorem"></span>\n    <span class="ipsum"></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.notHasClass)('lorem', 'span', { at: 1 })
    });

    assert.ok(page.foo);
  });
});
define('dummy/tests/unit/predicates/not-has-class-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/predicates');
  QUnit.test('unit/predicates/not-has-class-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/predicates/not-has-class-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/queries/attribute-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .attribute');

  (0, _qunit.test)('returns attribute value', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<input placeholder="a value">');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input')
    });

    assert.equal(page.foo, 'a value');
  });

  (0, _qunit.test)("returns null when attribute doesn't exist", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<input>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input')
    });

    assert.equal(page.foo, null);
  });

  (0, _qunit.test)("raises an error when the element doesn't exist", function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input')
    });

    assert.throws(function () {
      return page.foo;
    }, 'Throws element not found error');
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><input></div>\n    <div class="scope"><input placeholder="a value"></div>\n    <div><input></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input', { scope: '.scope' })
    });

    assert.equal(page.foo, 'a value');
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><input></div>\n    <div class="scope"><input placeholder="a value"></div>\n    <div><input></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input')
    });

    assert.equal(page.foo, 'a value');
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div class="scope"></div>\n    <div><input placeholder="a value"></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input', { resetScope: true })
    });

    assert.equal(page.foo, 'a value');
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <input placeholder="a value">\n    <input placeholder="other value">\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input')
    });

    return page.foo;
  });

  (0, _qunit.test)('matches multiple elements', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <input placeholder="a value">\n    <input placeholder="other value">\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input', { multiple: true })
    });

    assert.deepEqual(page.foo, ['a value', 'other value']);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <input>\n    <input placeholder="a value">\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.attribute)('placeholder', ':input', { at: 1 })
    });

    assert.equal(page.foo, 'a value');
  });
});
define('dummy/tests/unit/queries/attribute-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/queries');
  QUnit.test('unit/queries/attribute-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/queries/attribute-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/queries/count-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .count');

  (0, _qunit.test)('returns the number of elements that match the selector', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span></span>\n    <span></span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.count)('span')
    });

    assert.equal(page.foo, 2);
  });

  (0, _qunit.test)('returns 0 when the no element is matched', function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.count)('span')
    });

    assert.equal(page.foo, 0);
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span></span></div>\n    <div class="scope"><span></span><span></span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.count)('span', { scope: '.scope' })
    });

    assert.equal(page.foo, 2);
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span></span></div>\n    <div class="scope"><span></span><span></span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.count)('span')
    });

    assert.equal(page.foo, 2);
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div class="scope"></div>\n    <div><span></span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.count)('span', { resetScope: true })
    });

    assert.equal(page.foo, 1);
  });

  (0, _qunit.test)('resets multiple value', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span></span></div>\n    <div class="scope"><span></span><span></span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.count)('span', { multiple: false })
    });

    assert.equal(page.foo, 2);
  });
});
define('dummy/tests/unit/queries/count-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/queries');
  QUnit.test('unit/queries/count-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/queries/count-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/queries/text-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .text');

  (0, _qunit.test)('returns the inner text of the element', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('Hello <span>world!</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span')
    });

    assert.equal(page.foo, 'world!');
  });

  (0, _qunit.test)('removes white spaces from the beginning and end of the text', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<span>  awesome!  </span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span')
    });

    assert.equal(page.foo, 'awesome!');
  });

  (0, _qunit.test)('normalizes inner text of the element containing newlines', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)(['<span>', 'Hello', 'multi-line', 'world!', '</span>'].join("\n"));

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span')
    });

    assert.equal(page.foo, 'Hello multi-line world!');
  });

  (0, _qunit.test)('converts &nbsp; characters into standard whitespace characters', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<span>This&nbsp;is&nbsp;awesome.</span>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span')
    });

    assert.equal(page.foo, 'This is awesome.');
  });

  (0, _qunit.test)('returns empty text when the element doesn\'t have text', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<span />');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span')
    });

    assert.equal(page.foo, '');
  });

  (0, _qunit.test)("raises an error when the element doesn't exist", function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span')
    });

    assert.throws(function () {
      return page.foo;
    }, 'Throws element not found error');
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span', { scope: '.scope' })
    });

    assert.equal(page.foo, 'ipsum');
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span>ipsum</span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.text)('span')
    });

    assert.equal(page.foo, 'ipsum');
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><span>lorem</span></div>\n    <div class="scope"><span> ipsum </span></div>\n    <div><span>dolor</span></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.text)('span', { at: 0, resetScope: true })
    });

    assert.equal(page.foo, 'lorem');
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span>ipsum</span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('span', { at: 1 })
    });

    assert.equal(page.foo, 'ipsum');
  });

  (0, _qunit.test)('finds element without using a selector', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<div>Hello <span>world!</span></div>');

    var page = (0, _dummyTestsPageObject.create)({
      scope: 'div',

      foo: (0, _dummyTestsPageObject.text)(),

      bar: {
        scope: 'span',

        baz: (0, _dummyTestsPageObject.text)()
      }
    });

    assert.equal(page.foo, 'Hello world!');
    assert.equal(page.bar.baz, 'world!');
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <span>lorem</span>\n    <span> ipsum </span>\n    <span>dolor</span>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.text)('span', { resetScope: true })
    });

    return page.foo;
  });

  (0, _qunit.test)('returns multiple values', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <ul>\n      <li>lorem</li>\n      <li> ipsum </li>\n      <li>dolor</li>\n    </ul>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.text)('li', { multiple: true })
    });

    assert.deepEqual(page.foo, ['lorem', 'ipsum', 'dolor']);
  });
});
define('dummy/tests/unit/queries/text-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/queries');
  QUnit.test('unit/queries/text-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/queries/text-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/queries/value-test', ['exports', 'qunit', 'dummy/tests/unit/test-helper', 'dummy/tests/page-object', 'dummy/tests/unit/shared'], function (exports, _qunit, _dummyTestsUnitTestHelper, _dummyTestsPageObject, _dummyTestsUnitShared) {

  (0, _dummyTestsUnitTestHelper.moduleFor)('Unit | Property | .value');

  (0, _qunit.test)('returns the text of the input', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<input value="Lorem ipsum">');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.value)('input')
    });

    assert.equal(page.foo, 'Lorem ipsum');
  });

  (0, _qunit.test)('returns empty when the element doesn\'t have value attribute', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('<input>');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.value)('input')
    });

    assert.equal(page.foo, '');
  });

  (0, _qunit.test)("raises an error when the element doesn't exist", function (assert) {
    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.value)('input')
    });

    assert.throws(function () {
      return page.foo;
    }, 'Throws element not found error');
  });

  (0, _qunit.test)('looks for elements inside the scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><input value="lorem"></div>\n    <div class="scope"><input value="ipsum"></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.value)('input', { scope: '.scope' })
    });

    assert.equal(page.foo, 'ipsum');
  });

  (0, _qunit.test)("looks for elements inside page's scope", function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><input value="lorem"></div>\n    <div class="scope"><input value="ipsum"></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.value)('input')
    });

    assert.equal(page.foo, 'ipsum');
  });

  (0, _qunit.test)('resets scope', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <div><input value="lorem"></div>\n    <div class="scope"><input value="ipsum"></div>\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      scope: '.scope',

      foo: (0, _dummyTestsPageObject.value)('input', { at: 0, resetScope: true })
    });

    assert.equal(page.foo, 'lorem');
  });

  (0, _dummyTestsUnitShared.test_throws_if_not_multiple)(function () {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <input value="lorem">\n    <input value="ipsum">\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.value)('input')
    });

    return page.foo;
  });

  (0, _qunit.test)('matches multiple elements with multiple: true option', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <input value="lorem">\n    <input value="ipsum">\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.value)('input', { multiple: true })
    });

    assert.deepEqual(page.foo, ["lorem", "ipsum"]);
  });

  (0, _qunit.test)('finds element by index', function (assert) {
    (0, _dummyTestsUnitTestHelper.fixture)('\n    <input value="lorem">\n    <input value="ipsum">\n  ');

    var page = (0, _dummyTestsPageObject.create)({
      foo: (0, _dummyTestsPageObject.value)('input', { at: 1 })
    });

    assert.equal(page.foo, 'ipsum');
  });
});
define('dummy/tests/unit/queries/value-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit/queries');
  QUnit.test('unit/queries/value-test.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/queries/value-test.js should pass jshint.');
  });
});
define('dummy/tests/unit/shared', ['exports', 'qunit'], function (exports, _qunit) {
  exports.test_throws_if_not_multiple = test_throws_if_not_multiple;

  function test_throws_if_not_multiple(fn) {
    (0, _qunit.test)('throws error if selector matches more than one element', function (assert) {
      assert.throws(fn, /matched more than one element. If this is not an error use { multiple: true }/);
    });
  }
});
define('dummy/tests/unit/shared.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit');
  QUnit.test('unit/shared.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/shared.js should pass jshint.');
  });
});
define('dummy/tests/unit/test-helper', ['exports', 'ember', 'qunit', 'dummy/tests/helpers/start-app'], function (exports, _ember, _qunit, _dummyTestsHelpersStartApp) {
  exports.moduleFor = moduleFor;
  exports.fixture = fixture;

  var application = undefined;

  function moduleFor(helperName) {
    (0, _qunit.module)('' + helperName, {
      beforeEach: function beforeEach() {
        application = (0, _dummyTestsHelpersStartApp['default'])();
      },
      afterEach: function afterEach() {
        _ember['default'].run(application, 'destroy');

        // Cleanup DOM
        $('#ember-testing').html('');
      }
    });
  }

  function fixture(str) {
    $('#ember-testing').html(str);
  }
});
define('dummy/tests/unit/test-helper.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint - unit');
  QUnit.test('unit/test-helper.js should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/test-helper.js should pass jshint.');
  });
});
/* jshint ignore:start */

require('dummy/tests/test-helper');
EmberENV.TESTS_FILE_LOADED = true;

/* jshint ignore:end */
//# sourceMappingURL=tests.map